/**************************************************
 * 
 * Button short pressed, long pressed
 * and double-click example
 * 
 * Created: 14.07.2012 11:04
 * 
 * Author: DF4IAN, df4ian@gmx.net
 *
 * REV V1.01 
 * 
 * content: button.c, button.h, Mega1284P_main.c
 *
 **************************************************/

//ATMega1284P: JTAG Fuse DISABLE
#include <avr/io.h>
#include "button.h"
#include <util/delay.h>
#include <avr/interrupt.h> 


//global vars
unsigned int timer1, timer2, timer3, timer4, timer5;
FLAGBYTE stateOfButton;



int main(void){	
	//init
	DDRC |= (1 << DDC5);				// LED for button double-click
	DDRD |= (1 << DDD4);				// LED for button short pressed
	DDRD |= (1 << DDD5);				// LED for button long pressed
	PORTA |= (1 << button);				// pull-up 
	DDRA &= ~(1 << DDA1);				// button


	
	init();	
	sei();		
	while (1) {
			 
				if (stateOfButton.buttonDoubleClicked) {
			 					PORTC ^= (1 << PC5); 
								stateOfButton.buttonDoubleClicked = 0; 
				}								
				
				if (stateOfButton.buttonShortTimePressed) {		
				 				PORTD ^= (1 << PD4);
								stateOfButton.buttonShortTimePressed = 0;
				}						 
				
				if (stateOfButton.buttonLongTimePressed ) {
								PORTD ^= (1 << PD5);
				 				stateOfButton.buttonLongTimePressed  = 0;					
				}		
				
	} 								
	
}